// ==============================================================
// Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC v2019.2 (64-bit)
// Copyright 1986-2019 Xilinx, Inc. All Rights Reserved.
// ==============================================================
#ifndef __linux__

#include "xstatus.h"
#include "xparameters.h"
#include "xfinalbfs_32.h"

extern XFinalbfs_32_Config XFinalbfs_32_ConfigTable[];

XFinalbfs_32_Config *XFinalbfs_32_LookupConfig(u16 DeviceId) {
	XFinalbfs_32_Config *ConfigPtr = NULL;

	int Index;

	for (Index = 0; Index < XPAR_XFINALBFS_32_NUM_INSTANCES; Index++) {
		if (XFinalbfs_32_ConfigTable[Index].DeviceId == DeviceId) {
			ConfigPtr = &XFinalbfs_32_ConfigTable[Index];
			break;
		}
	}

	return ConfigPtr;
}

int XFinalbfs_32_Initialize(XFinalbfs_32 *InstancePtr, u16 DeviceId) {
	XFinalbfs_32_Config *ConfigPtr;

	Xil_AssertNonvoid(InstancePtr != NULL);

	ConfigPtr = XFinalbfs_32_LookupConfig(DeviceId);
	if (ConfigPtr == NULL) {
		InstancePtr->IsReady = 0;
		return (XST_DEVICE_NOT_FOUND);
	}

	return XFinalbfs_32_CfgInitialize(InstancePtr, ConfigPtr);
}

#endif

