// ==============================================================
// Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC v2019.2 (64-bit)
// Copyright 1986-2019 Xilinx, Inc. All Rights Reserved.
// ==============================================================
`timescale 1ns/1ps
module FinalBFS_32_control_s_axi
#(parameter
    C_S_AXI_ADDR_WIDTH = 9,
    C_S_AXI_DATA_WIDTH = 32
)(
    input  wire                          ACLK,
    input  wire                          ARESET,
    input  wire                          ACLK_EN,
    input  wire [C_S_AXI_ADDR_WIDTH-1:0] AWADDR,
    input  wire                          AWVALID,
    output wire                          AWREADY,
    input  wire [C_S_AXI_DATA_WIDTH-1:0] WDATA,
    input  wire [C_S_AXI_DATA_WIDTH/8-1:0] WSTRB,
    input  wire                          WVALID,
    output wire                          WREADY,
    output wire [1:0]                    BRESP,
    output wire                          BVALID,
    input  wire                          BREADY,
    input  wire [C_S_AXI_ADDR_WIDTH-1:0] ARADDR,
    input  wire                          ARVALID,
    output wire                          ARREADY,
    output wire [C_S_AXI_DATA_WIDTH-1:0] RDATA,
    output wire [1:0]                    RRESP,
    output wire                          RVALID,
    input  wire                          RREADY,
    output wire                          interrupt,
    output wire                          ap_start,
    input  wire                          ap_done,
    input  wire                          ap_ready,
    input  wire                          ap_idle,
    output wire [31:0]                   csr_c_addr,
    output wire [31:0]                   csr_r_addr,
    output wire [31:0]                   csc_c_addr,
    output wire [31:0]                   csc_r_addr,
    output wire [31:0]                   level_addr,
    output wire [31:0]                   node_num,
    output wire [31:0]                   push_to_pull_level,
    output wire [31:0]                   pull_to_push_level,
    output wire [63:0]                   axi00_ptr0,
    output wire [63:0]                   axi01_ptr0,
    output wire [63:0]                   axi02_ptr0,
    output wire [63:0]                   axi03_ptr0,
    output wire [63:0]                   axi04_ptr0,
    output wire [63:0]                   axi05_ptr0,
    output wire [63:0]                   axi06_ptr0,
    output wire [63:0]                   axi07_ptr0,
    output wire [63:0]                   axi08_ptr0,
    output wire [63:0]                   axi09_ptr0,
    output wire [63:0]                   axi10_ptr0,
    output wire [63:0]                   axi11_ptr0,
    output wire [63:0]                   axi12_ptr0,
    output wire [63:0]                   axi13_ptr0,
    output wire [63:0]                   axi14_ptr0,
    output wire [63:0]                   axi15_ptr0
);
//------------------------Address Info-------------------
// 0x000 : Control signals
//         bit 0  - ap_start (Read/Write/COH)
//         bit 1  - ap_done (Read/COR)
//         bit 2  - ap_idle (Read)
//         bit 3  - ap_ready (Read)
//         bit 7  - auto_restart (Read/Write)
//         others - reserved
// 0x004 : Global Interrupt Enable Register
//         bit 0  - Global Interrupt Enable (Read/Write)
//         others - reserved
// 0x008 : IP Interrupt Enable Register (Read/Write)
//         bit 0  - Channel 0 (ap_done)
//         bit 1  - Channel 1 (ap_ready)
//         others - reserved
// 0x00c : IP Interrupt Status Register (Read/TOW)
//         bit 0  - Channel 0 (ap_done)
//         bit 1  - Channel 1 (ap_ready)
//         others - reserved
// 0x010 : Data signal of csr_c_addr
//         bit 31~0 - csr_c_addr[31:0] (Read/Write)
// 0x014 : reserved
// 0x018 : Data signal of csr_r_addr
//         bit 31~0 - csr_r_addr[31:0] (Read/Write)
// 0x01c : reserved
// 0x020 : Data signal of csc_c_addr
//         bit 31~0 - csc_c_addr[31:0] (Read/Write)
// 0x024 : reserved
// 0x028 : Data signal of csc_r_addr
//         bit 31~0 - csc_r_addr[31:0] (Read/Write)
// 0x02c : reserved
// 0x030 : Data signal of level_addr
//         bit 31~0 - level_addr[31:0] (Read/Write)
// 0x034 : reserved
// 0x038 : Data signal of node_num
//         bit 31~0 - node_num[31:0] (Read/Write)
// 0x03c : reserved
// 0x040 : Data signal of push_to_pull_level
//         bit 31~0 - push_to_pull_level[31:0] (Read/Write)
// 0x044 : reserved
// 0x048 : Data signal of pull_to_push_level
//         bit 31~0 - pull_to_push_level[31:0] (Read/Write)
// 0x04c : reserved
// 0x050 : Data signal of axi00_ptr0
//         bit 31~0 - axi00_ptr0[31:0] (Read/Write)
// 0x054 : Data signal of axi00_ptr0
//         bit 31~0 - axi00_ptr0[63:32] (Read/Write)
// 0x058 : reserved
// 0x05c : Data signal of axi01_ptr0
//         bit 31~0 - axi01_ptr0[31:0] (Read/Write)
// 0x060 : Data signal of axi01_ptr0
//         bit 31~0 - axi01_ptr0[63:32] (Read/Write)
// 0x064 : reserved
// 0x068 : Data signal of axi02_ptr0
//         bit 31~0 - axi02_ptr0[31:0] (Read/Write)
// 0x06c : Data signal of axi02_ptr0
//         bit 31~0 - axi02_ptr0[63:32] (Read/Write)
// 0x070 : reserved
// 0x074 : Data signal of axi03_ptr0
//         bit 31~0 - axi03_ptr0[31:0] (Read/Write)
// 0x078 : Data signal of axi03_ptr0
//         bit 31~0 - axi03_ptr0[63:32] (Read/Write)
// 0x07c : reserved
// 0x080 : Data signal of axi04_ptr0
//         bit 31~0 - axi04_ptr0[31:0] (Read/Write)
// 0x084 : Data signal of axi04_ptr0
//         bit 31~0 - axi04_ptr0[63:32] (Read/Write)
// 0x088 : reserved
// 0x08c : Data signal of axi05_ptr0
//         bit 31~0 - axi05_ptr0[31:0] (Read/Write)
// 0x090 : Data signal of axi05_ptr0
//         bit 31~0 - axi05_ptr0[63:32] (Read/Write)
// 0x094 : reserved
// 0x098 : Data signal of axi06_ptr0
//         bit 31~0 - axi06_ptr0[31:0] (Read/Write)
// 0x09c : Data signal of axi06_ptr0
//         bit 31~0 - axi06_ptr0[63:32] (Read/Write)
// 0x0a0 : reserved
// 0x0a4 : Data signal of axi07_ptr0
//         bit 31~0 - axi07_ptr0[31:0] (Read/Write)
// 0x0a8 : Data signal of axi07_ptr0
//         bit 31~0 - axi07_ptr0[63:32] (Read/Write)
// 0x0ac : reserved
// 0x0b0 : Data signal of axi08_ptr0
//         bit 31~0 - axi08_ptr0[31:0] (Read/Write)
// 0x0b4 : Data signal of axi08_ptr0
//         bit 31~0 - axi08_ptr0[63:32] (Read/Write)
// 0x0b8 : reserved
// 0x0bc : Data signal of axi09_ptr0
//         bit 31~0 - axi09_ptr0[31:0] (Read/Write)
// 0x0c0 : Data signal of axi09_ptr0
//         bit 31~0 - axi09_ptr0[63:32] (Read/Write)
// 0x0c4 : reserved
// 0x0c8 : Data signal of axi10_ptr0
//         bit 31~0 - axi10_ptr0[31:0] (Read/Write)
// 0x0cc : Data signal of axi10_ptr0
//         bit 31~0 - axi10_ptr0[63:32] (Read/Write)
// 0x0d0 : reserved
// 0x0d4 : Data signal of axi11_ptr0
//         bit 31~0 - axi11_ptr0[31:0] (Read/Write)
// 0x0d8 : Data signal of axi11_ptr0
//         bit 31~0 - axi11_ptr0[63:32] (Read/Write)
// 0x0dc : reserved
// 0x0e0 : Data signal of axi12_ptr0
//         bit 31~0 - axi12_ptr0[31:0] (Read/Write)
// 0x0e4 : Data signal of axi12_ptr0
//         bit 31~0 - axi12_ptr0[63:32] (Read/Write)
// 0x0e8 : reserved
// 0x0ec : Data signal of axi13_ptr0
//         bit 31~0 - axi13_ptr0[31:0] (Read/Write)
// 0x0f0 : Data signal of axi13_ptr0
//         bit 31~0 - axi13_ptr0[63:32] (Read/Write)
// 0x0f4 : reserved
// 0x0f8 : Data signal of axi14_ptr0
//         bit 31~0 - axi14_ptr0[31:0] (Read/Write)
// 0x0fc : Data signal of axi14_ptr0
//         bit 31~0 - axi14_ptr0[63:32] (Read/Write)
// 0x100 : reserved
// 0x104 : Data signal of axi15_ptr0
//         bit 31~0 - axi15_ptr0[31:0] (Read/Write)
// 0x108 : Data signal of axi15_ptr0
//         bit 31~0 - axi15_ptr0[63:32] (Read/Write)
// 0x10c : reserved
// (SC = Self Clear, COR = Clear on Read, TOW = Toggle on Write, COH = Clear on Handshake)

//------------------------Parameter----------------------
localparam
    ADDR_AP_CTRL                   = 9'h000,
    ADDR_GIE                       = 9'h004,
    ADDR_IER                       = 9'h008,
    ADDR_ISR                       = 9'h00c,
    ADDR_CSR_C_ADDR_DATA_0         = 9'h010,
    ADDR_CSR_C_ADDR_CTRL           = 9'h014,
    ADDR_CSR_R_ADDR_DATA_0         = 9'h018,
    ADDR_CSR_R_ADDR_CTRL           = 9'h01c,
    ADDR_CSC_C_ADDR_DATA_0         = 9'h020,
    ADDR_CSC_C_ADDR_CTRL           = 9'h024,
    ADDR_CSC_R_ADDR_DATA_0         = 9'h028,
    ADDR_CSC_R_ADDR_CTRL           = 9'h02c,
    ADDR_LEVEL_ADDR_DATA_0         = 9'h030,
    ADDR_LEVEL_ADDR_CTRL           = 9'h034,
    ADDR_NODE_NUM_DATA_0           = 9'h038,
    ADDR_NODE_NUM_CTRL             = 9'h03c,
    ADDR_PUSH_TO_PULL_LEVEL_DATA_0 = 9'h040,
    ADDR_PUSH_TO_PULL_LEVEL_CTRL   = 9'h044,
    ADDR_PULL_TO_PUSH_LEVEL_DATA_0 = 9'h048,
    ADDR_PULL_TO_PUSH_LEVEL_CTRL   = 9'h04c,
    ADDR_AXI00_PTR0_DATA_0         = 9'h050,
    ADDR_AXI00_PTR0_DATA_1         = 9'h054,
    ADDR_AXI00_PTR0_CTRL           = 9'h058,
    ADDR_AXI01_PTR0_DATA_0         = 9'h05c,
    ADDR_AXI01_PTR0_DATA_1         = 9'h060,
    ADDR_AXI01_PTR0_CTRL           = 9'h064,
    ADDR_AXI02_PTR0_DATA_0         = 9'h068,
    ADDR_AXI02_PTR0_DATA_1         = 9'h06c,
    ADDR_AXI02_PTR0_CTRL           = 9'h070,
    ADDR_AXI03_PTR0_DATA_0         = 9'h074,
    ADDR_AXI03_PTR0_DATA_1         = 9'h078,
    ADDR_AXI03_PTR0_CTRL           = 9'h07c,
    ADDR_AXI04_PTR0_DATA_0         = 9'h080,
    ADDR_AXI04_PTR0_DATA_1         = 9'h084,
    ADDR_AXI04_PTR0_CTRL           = 9'h088,
    ADDR_AXI05_PTR0_DATA_0         = 9'h08c,
    ADDR_AXI05_PTR0_DATA_1         = 9'h090,
    ADDR_AXI05_PTR0_CTRL           = 9'h094,
    ADDR_AXI06_PTR0_DATA_0         = 9'h098,
    ADDR_AXI06_PTR0_DATA_1         = 9'h09c,
    ADDR_AXI06_PTR0_CTRL           = 9'h0a0,
    ADDR_AXI07_PTR0_DATA_0         = 9'h0a4,
    ADDR_AXI07_PTR0_DATA_1         = 9'h0a8,
    ADDR_AXI07_PTR0_CTRL           = 9'h0ac,
    ADDR_AXI08_PTR0_DATA_0         = 9'h0b0,
    ADDR_AXI08_PTR0_DATA_1         = 9'h0b4,
    ADDR_AXI08_PTR0_CTRL           = 9'h0b8,
    ADDR_AXI09_PTR0_DATA_0         = 9'h0bc,
    ADDR_AXI09_PTR0_DATA_1         = 9'h0c0,
    ADDR_AXI09_PTR0_CTRL           = 9'h0c4,
    ADDR_AXI10_PTR0_DATA_0         = 9'h0c8,
    ADDR_AXI10_PTR0_DATA_1         = 9'h0cc,
    ADDR_AXI10_PTR0_CTRL           = 9'h0d0,
    ADDR_AXI11_PTR0_DATA_0         = 9'h0d4,
    ADDR_AXI11_PTR0_DATA_1         = 9'h0d8,
    ADDR_AXI11_PTR0_CTRL           = 9'h0dc,
    ADDR_AXI12_PTR0_DATA_0         = 9'h0e0,
    ADDR_AXI12_PTR0_DATA_1         = 9'h0e4,
    ADDR_AXI12_PTR0_CTRL           = 9'h0e8,
    ADDR_AXI13_PTR0_DATA_0         = 9'h0ec,
    ADDR_AXI13_PTR0_DATA_1         = 9'h0f0,
    ADDR_AXI13_PTR0_CTRL           = 9'h0f4,
    ADDR_AXI14_PTR0_DATA_0         = 9'h0f8,
    ADDR_AXI14_PTR0_DATA_1         = 9'h0fc,
    ADDR_AXI14_PTR0_CTRL           = 9'h100,
    ADDR_AXI15_PTR0_DATA_0         = 9'h104,
    ADDR_AXI15_PTR0_DATA_1         = 9'h108,
    ADDR_AXI15_PTR0_CTRL           = 9'h10c,
    WRIDLE                         = 2'd0,
    WRDATA                         = 2'd1,
    WRRESP                         = 2'd2,
    WRRESET                        = 2'd3,
    RDIDLE                         = 2'd0,
    RDDATA                         = 2'd1,
    RDRESET                        = 2'd2,
    ADDR_BITS         = 9;

//------------------------Local signal-------------------
    reg  [1:0]                    wstate = WRRESET;
    reg  [1:0]                    wnext;
    reg  [ADDR_BITS-1:0]          waddr;
    wire [31:0]                   wmask;
    wire                          aw_hs;
    wire                          w_hs;
    reg  [1:0]                    rstate = RDRESET;
    reg  [1:0]                    rnext;
    reg  [31:0]                   rdata;
    wire                          ar_hs;
    wire [ADDR_BITS-1:0]          raddr;
    // internal registers
    reg                           int_ap_idle;
    reg                           int_ap_ready;
    reg                           int_ap_done = 1'b0;
    reg                           int_ap_start = 1'b0;
    reg                           int_auto_restart = 1'b0;
    reg                           int_gie = 1'b0;
    reg  [1:0]                    int_ier = 2'b0;
    reg  [1:0]                    int_isr = 2'b0;
    reg  [31:0]                   int_csr_c_addr = 'b0;
    reg  [31:0]                   int_csr_r_addr = 'b0;
    reg  [31:0]                   int_csc_c_addr = 'b0;
    reg  [31:0]                   int_csc_r_addr = 'b0;
    reg  [31:0]                   int_level_addr = 'b0;
    reg  [31:0]                   int_node_num = 'b0;
    reg  [31:0]                   int_push_to_pull_level = 'b0;
    reg  [31:0]                   int_pull_to_push_level = 'b0;
    reg  [63:0]                   int_axi00_ptr0 = 'b0;
    reg  [63:0]                   int_axi01_ptr0 = 'b0;
    reg  [63:0]                   int_axi02_ptr0 = 'b0;
    reg  [63:0]                   int_axi03_ptr0 = 'b0;
    reg  [63:0]                   int_axi04_ptr0 = 'b0;
    reg  [63:0]                   int_axi05_ptr0 = 'b0;
    reg  [63:0]                   int_axi06_ptr0 = 'b0;
    reg  [63:0]                   int_axi07_ptr0 = 'b0;
    reg  [63:0]                   int_axi08_ptr0 = 'b0;
    reg  [63:0]                   int_axi09_ptr0 = 'b0;
    reg  [63:0]                   int_axi10_ptr0 = 'b0;
    reg  [63:0]                   int_axi11_ptr0 = 'b0;
    reg  [63:0]                   int_axi12_ptr0 = 'b0;
    reg  [63:0]                   int_axi13_ptr0 = 'b0;
    reg  [63:0]                   int_axi14_ptr0 = 'b0;
    reg  [63:0]                   int_axi15_ptr0 = 'b0;

//------------------------Instantiation------------------

//------------------------AXI write fsm------------------
assign AWREADY = (wstate == WRIDLE);
assign WREADY  = (wstate == WRDATA);
assign BRESP   = 2'b00;  // OKAY
assign BVALID  = (wstate == WRRESP);
assign wmask   = { {8{WSTRB[3]}}, {8{WSTRB[2]}}, {8{WSTRB[1]}}, {8{WSTRB[0]}} };
assign aw_hs   = AWVALID & AWREADY;
assign w_hs    = WVALID & WREADY;

// wstate
always @(posedge ACLK) begin
    if (ARESET)
        wstate <= WRRESET;
    else if (ACLK_EN)
        wstate <= wnext;
end

// wnext
always @(*) begin
    case (wstate)
        WRIDLE:
            if (AWVALID)
                wnext = WRDATA;
            else
                wnext = WRIDLE;
        WRDATA:
            if (WVALID)
                wnext = WRRESP;
            else
                wnext = WRDATA;
        WRRESP:
            if (BREADY)
                wnext = WRIDLE;
            else
                wnext = WRRESP;
        default:
            wnext = WRIDLE;
    endcase
end

// waddr
always @(posedge ACLK) begin
    if (ACLK_EN) begin
        if (aw_hs)
            waddr <= AWADDR[ADDR_BITS-1:0];
    end
end

//------------------------AXI read fsm-------------------
assign ARREADY = (rstate == RDIDLE);
assign RDATA   = rdata;
assign RRESP   = 2'b00;  // OKAY
assign RVALID  = (rstate == RDDATA);
assign ar_hs   = ARVALID & ARREADY;
assign raddr   = ARADDR[ADDR_BITS-1:0];

// rstate
always @(posedge ACLK) begin
    if (ARESET)
        rstate <= RDRESET;
    else if (ACLK_EN)
        rstate <= rnext;
end

// rnext
always @(*) begin
    case (rstate)
        RDIDLE:
            if (ARVALID)
                rnext = RDDATA;
            else
                rnext = RDIDLE;
        RDDATA:
            if (RREADY & RVALID)
                rnext = RDIDLE;
            else
                rnext = RDDATA;
        default:
            rnext = RDIDLE;
    endcase
end

// rdata
always @(posedge ACLK) begin
    if (ACLK_EN) begin
        if (ar_hs) begin
            rdata <= 1'b0;
            case (raddr)
                ADDR_AP_CTRL: begin
                    rdata[0] <= int_ap_start;
                    rdata[1] <= int_ap_done;
                    rdata[2] <= int_ap_idle;
                    rdata[3] <= int_ap_ready;
                    rdata[7] <= int_auto_restart;
                end
                ADDR_GIE: begin
                    rdata <= int_gie;
                end
                ADDR_IER: begin
                    rdata <= int_ier;
                end
                ADDR_ISR: begin
                    rdata <= int_isr;
                end
                ADDR_CSR_C_ADDR_DATA_0: begin
                    rdata <= int_csr_c_addr[31:0];
                end
                ADDR_CSR_R_ADDR_DATA_0: begin
                    rdata <= int_csr_r_addr[31:0];
                end
                ADDR_CSC_C_ADDR_DATA_0: begin
                    rdata <= int_csc_c_addr[31:0];
                end
                ADDR_CSC_R_ADDR_DATA_0: begin
                    rdata <= int_csc_r_addr[31:0];
                end
                ADDR_LEVEL_ADDR_DATA_0: begin
                    rdata <= int_level_addr[31:0];
                end
                ADDR_NODE_NUM_DATA_0: begin
                    rdata <= int_node_num[31:0];
                end
                ADDR_PUSH_TO_PULL_LEVEL_DATA_0: begin
                    rdata <= int_push_to_pull_level[31:0];
                end
                ADDR_PULL_TO_PUSH_LEVEL_DATA_0: begin
                    rdata <= int_pull_to_push_level[31:0];
                end
                ADDR_AXI00_PTR0_DATA_0: begin
                    rdata <= int_axi00_ptr0[31:0];
                end
                ADDR_AXI00_PTR0_DATA_1: begin
                    rdata <= int_axi00_ptr0[63:32];
                end
                ADDR_AXI01_PTR0_DATA_0: begin
                    rdata <= int_axi01_ptr0[31:0];
                end
                ADDR_AXI01_PTR0_DATA_1: begin
                    rdata <= int_axi01_ptr0[63:32];
                end
                ADDR_AXI02_PTR0_DATA_0: begin
                    rdata <= int_axi02_ptr0[31:0];
                end
                ADDR_AXI02_PTR0_DATA_1: begin
                    rdata <= int_axi02_ptr0[63:32];
                end
                ADDR_AXI03_PTR0_DATA_0: begin
                    rdata <= int_axi03_ptr0[31:0];
                end
                ADDR_AXI03_PTR0_DATA_1: begin
                    rdata <= int_axi03_ptr0[63:32];
                end
                ADDR_AXI04_PTR0_DATA_0: begin
                    rdata <= int_axi04_ptr0[31:0];
                end
                ADDR_AXI04_PTR0_DATA_1: begin
                    rdata <= int_axi04_ptr0[63:32];
                end
                ADDR_AXI05_PTR0_DATA_0: begin
                    rdata <= int_axi05_ptr0[31:0];
                end
                ADDR_AXI05_PTR0_DATA_1: begin
                    rdata <= int_axi05_ptr0[63:32];
                end
                ADDR_AXI06_PTR0_DATA_0: begin
                    rdata <= int_axi06_ptr0[31:0];
                end
                ADDR_AXI06_PTR0_DATA_1: begin
                    rdata <= int_axi06_ptr0[63:32];
                end
                ADDR_AXI07_PTR0_DATA_0: begin
                    rdata <= int_axi07_ptr0[31:0];
                end
                ADDR_AXI07_PTR0_DATA_1: begin
                    rdata <= int_axi07_ptr0[63:32];
                end
                ADDR_AXI08_PTR0_DATA_0: begin
                    rdata <= int_axi08_ptr0[31:0];
                end
                ADDR_AXI08_PTR0_DATA_1: begin
                    rdata <= int_axi08_ptr0[63:32];
                end
                ADDR_AXI09_PTR0_DATA_0: begin
                    rdata <= int_axi09_ptr0[31:0];
                end
                ADDR_AXI09_PTR0_DATA_1: begin
                    rdata <= int_axi09_ptr0[63:32];
                end
                ADDR_AXI10_PTR0_DATA_0: begin
                    rdata <= int_axi10_ptr0[31:0];
                end
                ADDR_AXI10_PTR0_DATA_1: begin
                    rdata <= int_axi10_ptr0[63:32];
                end
                ADDR_AXI11_PTR0_DATA_0: begin
                    rdata <= int_axi11_ptr0[31:0];
                end
                ADDR_AXI11_PTR0_DATA_1: begin
                    rdata <= int_axi11_ptr0[63:32];
                end
                ADDR_AXI12_PTR0_DATA_0: begin
                    rdata <= int_axi12_ptr0[31:0];
                end
                ADDR_AXI12_PTR0_DATA_1: begin
                    rdata <= int_axi12_ptr0[63:32];
                end
                ADDR_AXI13_PTR0_DATA_0: begin
                    rdata <= int_axi13_ptr0[31:0];
                end
                ADDR_AXI13_PTR0_DATA_1: begin
                    rdata <= int_axi13_ptr0[63:32];
                end
                ADDR_AXI14_PTR0_DATA_0: begin
                    rdata <= int_axi14_ptr0[31:0];
                end
                ADDR_AXI14_PTR0_DATA_1: begin
                    rdata <= int_axi14_ptr0[63:32];
                end
                ADDR_AXI15_PTR0_DATA_0: begin
                    rdata <= int_axi15_ptr0[31:0];
                end
                ADDR_AXI15_PTR0_DATA_1: begin
                    rdata <= int_axi15_ptr0[63:32];
                end
            endcase
        end
    end
end


//------------------------Register logic-----------------
assign interrupt          = int_gie & (|int_isr);
assign ap_start           = int_ap_start;
assign csr_c_addr         = int_csr_c_addr;
assign csr_r_addr         = int_csr_r_addr;
assign csc_c_addr         = int_csc_c_addr;
assign csc_r_addr         = int_csc_r_addr;
assign level_addr         = int_level_addr;
assign node_num           = int_node_num;
assign push_to_pull_level = int_push_to_pull_level;
assign pull_to_push_level = int_pull_to_push_level;
assign axi00_ptr0         = int_axi00_ptr0;
assign axi01_ptr0         = int_axi01_ptr0;
assign axi02_ptr0         = int_axi02_ptr0;
assign axi03_ptr0         = int_axi03_ptr0;
assign axi04_ptr0         = int_axi04_ptr0;
assign axi05_ptr0         = int_axi05_ptr0;
assign axi06_ptr0         = int_axi06_ptr0;
assign axi07_ptr0         = int_axi07_ptr0;
assign axi08_ptr0         = int_axi08_ptr0;
assign axi09_ptr0         = int_axi09_ptr0;
assign axi10_ptr0         = int_axi10_ptr0;
assign axi11_ptr0         = int_axi11_ptr0;
assign axi12_ptr0         = int_axi12_ptr0;
assign axi13_ptr0         = int_axi13_ptr0;
assign axi14_ptr0         = int_axi14_ptr0;
assign axi15_ptr0         = int_axi15_ptr0;
// int_ap_start
always @(posedge ACLK) begin
    if (ARESET)
        int_ap_start <= 1'b0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AP_CTRL && WSTRB[0] && WDATA[0])
            int_ap_start <= 1'b1;
        else if (ap_ready)
            int_ap_start <= int_auto_restart; // clear on handshake/auto restart
    end
end

// int_ap_done
always @(posedge ACLK) begin
    if (ARESET)
        int_ap_done <= 1'b0;
    else if (ACLK_EN) begin
        if (ap_done)
            int_ap_done <= 1'b1;
        else if (ar_hs && raddr == ADDR_AP_CTRL)
            int_ap_done <= 1'b0; // clear on read
    end
end

// int_ap_idle
always @(posedge ACLK) begin
    if (ARESET)
        int_ap_idle <= 1'b0;
    else if (ACLK_EN) begin
            int_ap_idle <= ap_idle;
    end
end

// int_ap_ready
always @(posedge ACLK) begin
    if (ARESET)
        int_ap_ready <= 1'b0;
    else if (ACLK_EN) begin
            int_ap_ready <= ap_ready;
    end
end

// int_auto_restart
always @(posedge ACLK) begin
    if (ARESET)
        int_auto_restart <= 1'b0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AP_CTRL && WSTRB[0])
            int_auto_restart <=  WDATA[7];
    end
end

// int_gie
always @(posedge ACLK) begin
    if (ARESET)
        int_gie <= 1'b0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_GIE && WSTRB[0])
            int_gie <= WDATA[0];
    end
end

// int_ier
always @(posedge ACLK) begin
    if (ARESET)
        int_ier <= 1'b0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_IER && WSTRB[0])
            int_ier <= WDATA[1:0];
    end
end

// int_isr[0]
always @(posedge ACLK) begin
    if (ARESET)
        int_isr[0] <= 1'b0;
    else if (ACLK_EN) begin
        if (int_ier[0] & ap_done)
            int_isr[0] <= 1'b1;
        else if (w_hs && waddr == ADDR_ISR && WSTRB[0])
            int_isr[0] <= int_isr[0] ^ WDATA[0]; // toggle on write
    end
end

// int_isr[1]
always @(posedge ACLK) begin
    if (ARESET)
        int_isr[1] <= 1'b0;
    else if (ACLK_EN) begin
        if (int_ier[1] & ap_ready)
            int_isr[1] <= 1'b1;
        else if (w_hs && waddr == ADDR_ISR && WSTRB[0])
            int_isr[1] <= int_isr[1] ^ WDATA[1]; // toggle on write
    end
end

// int_csr_c_addr[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_csr_c_addr[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_CSR_C_ADDR_DATA_0)
            int_csr_c_addr[31:0] <= (WDATA[31:0] & wmask) | (int_csr_c_addr[31:0] & ~wmask);
    end
end

// int_csr_r_addr[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_csr_r_addr[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_CSR_R_ADDR_DATA_0)
            int_csr_r_addr[31:0] <= (WDATA[31:0] & wmask) | (int_csr_r_addr[31:0] & ~wmask);
    end
end

// int_csc_c_addr[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_csc_c_addr[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_CSC_C_ADDR_DATA_0)
            int_csc_c_addr[31:0] <= (WDATA[31:0] & wmask) | (int_csc_c_addr[31:0] & ~wmask);
    end
end

// int_csc_r_addr[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_csc_r_addr[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_CSC_R_ADDR_DATA_0)
            int_csc_r_addr[31:0] <= (WDATA[31:0] & wmask) | (int_csc_r_addr[31:0] & ~wmask);
    end
end

// int_level_addr[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_level_addr[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_LEVEL_ADDR_DATA_0)
            int_level_addr[31:0] <= (WDATA[31:0] & wmask) | (int_level_addr[31:0] & ~wmask);
    end
end

// int_node_num[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_node_num[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_NODE_NUM_DATA_0)
            int_node_num[31:0] <= (WDATA[31:0] & wmask) | (int_node_num[31:0] & ~wmask);
    end
end

// int_push_to_pull_level[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_push_to_pull_level[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_PUSH_TO_PULL_LEVEL_DATA_0)
            int_push_to_pull_level[31:0] <= (WDATA[31:0] & wmask) | (int_push_to_pull_level[31:0] & ~wmask);
    end
end

// int_pull_to_push_level[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_pull_to_push_level[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_PULL_TO_PUSH_LEVEL_DATA_0)
            int_pull_to_push_level[31:0] <= (WDATA[31:0] & wmask) | (int_pull_to_push_level[31:0] & ~wmask);
    end
end

// int_axi00_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi00_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI00_PTR0_DATA_0)
            int_axi00_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi00_ptr0[31:0] & ~wmask);
    end
end

// int_axi00_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi00_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI00_PTR0_DATA_1)
            int_axi00_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi00_ptr0[63:32] & ~wmask);
    end
end

// int_axi01_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi01_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI01_PTR0_DATA_0)
            int_axi01_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi01_ptr0[31:0] & ~wmask);
    end
end

// int_axi01_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi01_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI01_PTR0_DATA_1)
            int_axi01_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi01_ptr0[63:32] & ~wmask);
    end
end

// int_axi02_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi02_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI02_PTR0_DATA_0)
            int_axi02_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi02_ptr0[31:0] & ~wmask);
    end
end

// int_axi02_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi02_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI02_PTR0_DATA_1)
            int_axi02_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi02_ptr0[63:32] & ~wmask);
    end
end

// int_axi03_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi03_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI03_PTR0_DATA_0)
            int_axi03_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi03_ptr0[31:0] & ~wmask);
    end
end

// int_axi03_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi03_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI03_PTR0_DATA_1)
            int_axi03_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi03_ptr0[63:32] & ~wmask);
    end
end

// int_axi04_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi04_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI04_PTR0_DATA_0)
            int_axi04_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi04_ptr0[31:0] & ~wmask);
    end
end

// int_axi04_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi04_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI04_PTR0_DATA_1)
            int_axi04_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi04_ptr0[63:32] & ~wmask);
    end
end

// int_axi05_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi05_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI05_PTR0_DATA_0)
            int_axi05_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi05_ptr0[31:0] & ~wmask);
    end
end

// int_axi05_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi05_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI05_PTR0_DATA_1)
            int_axi05_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi05_ptr0[63:32] & ~wmask);
    end
end

// int_axi06_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi06_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI06_PTR0_DATA_0)
            int_axi06_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi06_ptr0[31:0] & ~wmask);
    end
end

// int_axi06_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi06_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI06_PTR0_DATA_1)
            int_axi06_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi06_ptr0[63:32] & ~wmask);
    end
end

// int_axi07_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi07_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI07_PTR0_DATA_0)
            int_axi07_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi07_ptr0[31:0] & ~wmask);
    end
end

// int_axi07_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi07_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI07_PTR0_DATA_1)
            int_axi07_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi07_ptr0[63:32] & ~wmask);
    end
end

// int_axi08_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi08_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI08_PTR0_DATA_0)
            int_axi08_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi08_ptr0[31:0] & ~wmask);
    end
end

// int_axi08_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi08_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI08_PTR0_DATA_1)
            int_axi08_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi08_ptr0[63:32] & ~wmask);
    end
end

// int_axi09_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi09_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI09_PTR0_DATA_0)
            int_axi09_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi09_ptr0[31:0] & ~wmask);
    end
end

// int_axi09_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi09_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI09_PTR0_DATA_1)
            int_axi09_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi09_ptr0[63:32] & ~wmask);
    end
end

// int_axi10_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi10_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI10_PTR0_DATA_0)
            int_axi10_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi10_ptr0[31:0] & ~wmask);
    end
end

// int_axi10_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi10_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI10_PTR0_DATA_1)
            int_axi10_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi10_ptr0[63:32] & ~wmask);
    end
end

// int_axi11_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi11_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI11_PTR0_DATA_0)
            int_axi11_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi11_ptr0[31:0] & ~wmask);
    end
end

// int_axi11_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi11_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI11_PTR0_DATA_1)
            int_axi11_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi11_ptr0[63:32] & ~wmask);
    end
end

// int_axi12_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi12_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI12_PTR0_DATA_0)
            int_axi12_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi12_ptr0[31:0] & ~wmask);
    end
end

// int_axi12_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi12_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI12_PTR0_DATA_1)
            int_axi12_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi12_ptr0[63:32] & ~wmask);
    end
end

// int_axi13_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi13_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI13_PTR0_DATA_0)
            int_axi13_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi13_ptr0[31:0] & ~wmask);
    end
end

// int_axi13_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi13_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI13_PTR0_DATA_1)
            int_axi13_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi13_ptr0[63:32] & ~wmask);
    end
end

// int_axi14_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi14_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI14_PTR0_DATA_0)
            int_axi14_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi14_ptr0[31:0] & ~wmask);
    end
end

// int_axi14_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi14_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI14_PTR0_DATA_1)
            int_axi14_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi14_ptr0[63:32] & ~wmask);
    end
end

// int_axi15_ptr0[31:0]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi15_ptr0[31:0] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI15_PTR0_DATA_0)
            int_axi15_ptr0[31:0] <= (WDATA[31:0] & wmask) | (int_axi15_ptr0[31:0] & ~wmask);
    end
end

// int_axi15_ptr0[63:32]
always @(posedge ACLK) begin
    if (ARESET)
        int_axi15_ptr0[63:32] <= 0;
    else if (ACLK_EN) begin
        if (w_hs && waddr == ADDR_AXI15_PTR0_DATA_1)
            int_axi15_ptr0[63:32] <= (WDATA[31:0] & wmask) | (int_axi15_ptr0[63:32] & ~wmask);
    end
end


//------------------------Memory logic-------------------

endmodule
