-- ==============================================================
-- Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC v2019.2 (64-bit)
-- Copyright 1986-2019 Xilinx, Inc. All Rights Reserved.
-- ==============================================================
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

entity FinalBFS_32_control_s_axi is
generic (
    C_S_AXI_ADDR_WIDTH    : INTEGER := 9;
    C_S_AXI_DATA_WIDTH    : INTEGER := 32);
port (
    ACLK                  :in   STD_LOGIC;
    ARESET                :in   STD_LOGIC;
    ACLK_EN               :in   STD_LOGIC;
    AWADDR                :in   STD_LOGIC_VECTOR(C_S_AXI_ADDR_WIDTH-1 downto 0);
    AWVALID               :in   STD_LOGIC;
    AWREADY               :out  STD_LOGIC;
    WDATA                 :in   STD_LOGIC_VECTOR(C_S_AXI_DATA_WIDTH-1 downto 0);
    WSTRB                 :in   STD_LOGIC_VECTOR(C_S_AXI_DATA_WIDTH/8-1 downto 0);
    WVALID                :in   STD_LOGIC;
    WREADY                :out  STD_LOGIC;
    BRESP                 :out  STD_LOGIC_VECTOR(1 downto 0);
    BVALID                :out  STD_LOGIC;
    BREADY                :in   STD_LOGIC;
    ARADDR                :in   STD_LOGIC_VECTOR(C_S_AXI_ADDR_WIDTH-1 downto 0);
    ARVALID               :in   STD_LOGIC;
    ARREADY               :out  STD_LOGIC;
    RDATA                 :out  STD_LOGIC_VECTOR(C_S_AXI_DATA_WIDTH-1 downto 0);
    RRESP                 :out  STD_LOGIC_VECTOR(1 downto 0);
    RVALID                :out  STD_LOGIC;
    RREADY                :in   STD_LOGIC;
    interrupt             :out  STD_LOGIC;
    ap_start              :out  STD_LOGIC;
    ap_done               :in   STD_LOGIC;
    ap_ready              :in   STD_LOGIC;
    ap_idle               :in   STD_LOGIC;
    csr_c_addr            :out  STD_LOGIC_VECTOR(31 downto 0);
    csr_r_addr            :out  STD_LOGIC_VECTOR(31 downto 0);
    csc_c_addr            :out  STD_LOGIC_VECTOR(31 downto 0);
    csc_r_addr            :out  STD_LOGIC_VECTOR(31 downto 0);
    level_addr            :out  STD_LOGIC_VECTOR(31 downto 0);
    node_num              :out  STD_LOGIC_VECTOR(31 downto 0);
    push_to_pull_level    :out  STD_LOGIC_VECTOR(31 downto 0);
    pull_to_push_level    :out  STD_LOGIC_VECTOR(31 downto 0);
    axi00_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi01_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi02_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi03_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi04_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi05_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi06_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi07_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi08_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi09_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi10_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi11_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi12_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi13_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi14_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0);
    axi15_ptr0            :out  STD_LOGIC_VECTOR(63 downto 0)
);
end entity FinalBFS_32_control_s_axi;

-- ------------------------Address Info-------------------
-- 0x000 : Control signals
--         bit 0  - ap_start (Read/Write/COH)
--         bit 1  - ap_done (Read/COR)
--         bit 2  - ap_idle (Read)
--         bit 3  - ap_ready (Read)
--         bit 7  - auto_restart (Read/Write)
--         others - reserved
-- 0x004 : Global Interrupt Enable Register
--         bit 0  - Global Interrupt Enable (Read/Write)
--         others - reserved
-- 0x008 : IP Interrupt Enable Register (Read/Write)
--         bit 0  - Channel 0 (ap_done)
--         bit 1  - Channel 1 (ap_ready)
--         others - reserved
-- 0x00c : IP Interrupt Status Register (Read/TOW)
--         bit 0  - Channel 0 (ap_done)
--         bit 1  - Channel 1 (ap_ready)
--         others - reserved
-- 0x010 : Data signal of csr_c_addr
--         bit 31~0 - csr_c_addr[31:0] (Read/Write)
-- 0x014 : reserved
-- 0x018 : Data signal of csr_r_addr
--         bit 31~0 - csr_r_addr[31:0] (Read/Write)
-- 0x01c : reserved
-- 0x020 : Data signal of csc_c_addr
--         bit 31~0 - csc_c_addr[31:0] (Read/Write)
-- 0x024 : reserved
-- 0x028 : Data signal of csc_r_addr
--         bit 31~0 - csc_r_addr[31:0] (Read/Write)
-- 0x02c : reserved
-- 0x030 : Data signal of level_addr
--         bit 31~0 - level_addr[31:0] (Read/Write)
-- 0x034 : reserved
-- 0x038 : Data signal of node_num
--         bit 31~0 - node_num[31:0] (Read/Write)
-- 0x03c : reserved
-- 0x040 : Data signal of push_to_pull_level
--         bit 31~0 - push_to_pull_level[31:0] (Read/Write)
-- 0x044 : reserved
-- 0x048 : Data signal of pull_to_push_level
--         bit 31~0 - pull_to_push_level[31:0] (Read/Write)
-- 0x04c : reserved
-- 0x050 : Data signal of axi00_ptr0
--         bit 31~0 - axi00_ptr0[31:0] (Read/Write)
-- 0x054 : Data signal of axi00_ptr0
--         bit 31~0 - axi00_ptr0[63:32] (Read/Write)
-- 0x058 : reserved
-- 0x05c : Data signal of axi01_ptr0
--         bit 31~0 - axi01_ptr0[31:0] (Read/Write)
-- 0x060 : Data signal of axi01_ptr0
--         bit 31~0 - axi01_ptr0[63:32] (Read/Write)
-- 0x064 : reserved
-- 0x068 : Data signal of axi02_ptr0
--         bit 31~0 - axi02_ptr0[31:0] (Read/Write)
-- 0x06c : Data signal of axi02_ptr0
--         bit 31~0 - axi02_ptr0[63:32] (Read/Write)
-- 0x070 : reserved
-- 0x074 : Data signal of axi03_ptr0
--         bit 31~0 - axi03_ptr0[31:0] (Read/Write)
-- 0x078 : Data signal of axi03_ptr0
--         bit 31~0 - axi03_ptr0[63:32] (Read/Write)
-- 0x07c : reserved
-- 0x080 : Data signal of axi04_ptr0
--         bit 31~0 - axi04_ptr0[31:0] (Read/Write)
-- 0x084 : Data signal of axi04_ptr0
--         bit 31~0 - axi04_ptr0[63:32] (Read/Write)
-- 0x088 : reserved
-- 0x08c : Data signal of axi05_ptr0
--         bit 31~0 - axi05_ptr0[31:0] (Read/Write)
-- 0x090 : Data signal of axi05_ptr0
--         bit 31~0 - axi05_ptr0[63:32] (Read/Write)
-- 0x094 : reserved
-- 0x098 : Data signal of axi06_ptr0
--         bit 31~0 - axi06_ptr0[31:0] (Read/Write)
-- 0x09c : Data signal of axi06_ptr0
--         bit 31~0 - axi06_ptr0[63:32] (Read/Write)
-- 0x0a0 : reserved
-- 0x0a4 : Data signal of axi07_ptr0
--         bit 31~0 - axi07_ptr0[31:0] (Read/Write)
-- 0x0a8 : Data signal of axi07_ptr0
--         bit 31~0 - axi07_ptr0[63:32] (Read/Write)
-- 0x0ac : reserved
-- 0x0b0 : Data signal of axi08_ptr0
--         bit 31~0 - axi08_ptr0[31:0] (Read/Write)
-- 0x0b4 : Data signal of axi08_ptr0
--         bit 31~0 - axi08_ptr0[63:32] (Read/Write)
-- 0x0b8 : reserved
-- 0x0bc : Data signal of axi09_ptr0
--         bit 31~0 - axi09_ptr0[31:0] (Read/Write)
-- 0x0c0 : Data signal of axi09_ptr0
--         bit 31~0 - axi09_ptr0[63:32] (Read/Write)
-- 0x0c4 : reserved
-- 0x0c8 : Data signal of axi10_ptr0
--         bit 31~0 - axi10_ptr0[31:0] (Read/Write)
-- 0x0cc : Data signal of axi10_ptr0
--         bit 31~0 - axi10_ptr0[63:32] (Read/Write)
-- 0x0d0 : reserved
-- 0x0d4 : Data signal of axi11_ptr0
--         bit 31~0 - axi11_ptr0[31:0] (Read/Write)
-- 0x0d8 : Data signal of axi11_ptr0
--         bit 31~0 - axi11_ptr0[63:32] (Read/Write)
-- 0x0dc : reserved
-- 0x0e0 : Data signal of axi12_ptr0
--         bit 31~0 - axi12_ptr0[31:0] (Read/Write)
-- 0x0e4 : Data signal of axi12_ptr0
--         bit 31~0 - axi12_ptr0[63:32] (Read/Write)
-- 0x0e8 : reserved
-- 0x0ec : Data signal of axi13_ptr0
--         bit 31~0 - axi13_ptr0[31:0] (Read/Write)
-- 0x0f0 : Data signal of axi13_ptr0
--         bit 31~0 - axi13_ptr0[63:32] (Read/Write)
-- 0x0f4 : reserved
-- 0x0f8 : Data signal of axi14_ptr0
--         bit 31~0 - axi14_ptr0[31:0] (Read/Write)
-- 0x0fc : Data signal of axi14_ptr0
--         bit 31~0 - axi14_ptr0[63:32] (Read/Write)
-- 0x100 : reserved
-- 0x104 : Data signal of axi15_ptr0
--         bit 31~0 - axi15_ptr0[31:0] (Read/Write)
-- 0x108 : Data signal of axi15_ptr0
--         bit 31~0 - axi15_ptr0[63:32] (Read/Write)
-- 0x10c : reserved
-- (SC = Self Clear, COR = Clear on Read, TOW = Toggle on Write, COH = Clear on Handshake)

architecture behave of FinalBFS_32_control_s_axi is
    type states is (wridle, wrdata, wrresp, wrreset, rdidle, rddata, rdreset);  -- read and write fsm states
    signal wstate  : states := wrreset;
    signal rstate  : states := rdreset;
    signal wnext, rnext: states;
    constant ADDR_AP_CTRL                   : INTEGER := 16#000#;
    constant ADDR_GIE                       : INTEGER := 16#004#;
    constant ADDR_IER                       : INTEGER := 16#008#;
    constant ADDR_ISR                       : INTEGER := 16#00c#;
    constant ADDR_CSR_C_ADDR_DATA_0         : INTEGER := 16#010#;
    constant ADDR_CSR_C_ADDR_CTRL           : INTEGER := 16#014#;
    constant ADDR_CSR_R_ADDR_DATA_0         : INTEGER := 16#018#;
    constant ADDR_CSR_R_ADDR_CTRL           : INTEGER := 16#01c#;
    constant ADDR_CSC_C_ADDR_DATA_0         : INTEGER := 16#020#;
    constant ADDR_CSC_C_ADDR_CTRL           : INTEGER := 16#024#;
    constant ADDR_CSC_R_ADDR_DATA_0         : INTEGER := 16#028#;
    constant ADDR_CSC_R_ADDR_CTRL           : INTEGER := 16#02c#;
    constant ADDR_LEVEL_ADDR_DATA_0         : INTEGER := 16#030#;
    constant ADDR_LEVEL_ADDR_CTRL           : INTEGER := 16#034#;
    constant ADDR_NODE_NUM_DATA_0           : INTEGER := 16#038#;
    constant ADDR_NODE_NUM_CTRL             : INTEGER := 16#03c#;
    constant ADDR_PUSH_TO_PULL_LEVEL_DATA_0 : INTEGER := 16#040#;
    constant ADDR_PUSH_TO_PULL_LEVEL_CTRL   : INTEGER := 16#044#;
    constant ADDR_PULL_TO_PUSH_LEVEL_DATA_0 : INTEGER := 16#048#;
    constant ADDR_PULL_TO_PUSH_LEVEL_CTRL   : INTEGER := 16#04c#;
    constant ADDR_AXI00_PTR0_DATA_0         : INTEGER := 16#050#;
    constant ADDR_AXI00_PTR0_DATA_1         : INTEGER := 16#054#;
    constant ADDR_AXI00_PTR0_CTRL           : INTEGER := 16#058#;
    constant ADDR_AXI01_PTR0_DATA_0         : INTEGER := 16#05c#;
    constant ADDR_AXI01_PTR0_DATA_1         : INTEGER := 16#060#;
    constant ADDR_AXI01_PTR0_CTRL           : INTEGER := 16#064#;
    constant ADDR_AXI02_PTR0_DATA_0         : INTEGER := 16#068#;
    constant ADDR_AXI02_PTR0_DATA_1         : INTEGER := 16#06c#;
    constant ADDR_AXI02_PTR0_CTRL           : INTEGER := 16#070#;
    constant ADDR_AXI03_PTR0_DATA_0         : INTEGER := 16#074#;
    constant ADDR_AXI03_PTR0_DATA_1         : INTEGER := 16#078#;
    constant ADDR_AXI03_PTR0_CTRL           : INTEGER := 16#07c#;
    constant ADDR_AXI04_PTR0_DATA_0         : INTEGER := 16#080#;
    constant ADDR_AXI04_PTR0_DATA_1         : INTEGER := 16#084#;
    constant ADDR_AXI04_PTR0_CTRL           : INTEGER := 16#088#;
    constant ADDR_AXI05_PTR0_DATA_0         : INTEGER := 16#08c#;
    constant ADDR_AXI05_PTR0_DATA_1         : INTEGER := 16#090#;
    constant ADDR_AXI05_PTR0_CTRL           : INTEGER := 16#094#;
    constant ADDR_AXI06_PTR0_DATA_0         : INTEGER := 16#098#;
    constant ADDR_AXI06_PTR0_DATA_1         : INTEGER := 16#09c#;
    constant ADDR_AXI06_PTR0_CTRL           : INTEGER := 16#0a0#;
    constant ADDR_AXI07_PTR0_DATA_0         : INTEGER := 16#0a4#;
    constant ADDR_AXI07_PTR0_DATA_1         : INTEGER := 16#0a8#;
    constant ADDR_AXI07_PTR0_CTRL           : INTEGER := 16#0ac#;
    constant ADDR_AXI08_PTR0_DATA_0         : INTEGER := 16#0b0#;
    constant ADDR_AXI08_PTR0_DATA_1         : INTEGER := 16#0b4#;
    constant ADDR_AXI08_PTR0_CTRL           : INTEGER := 16#0b8#;
    constant ADDR_AXI09_PTR0_DATA_0         : INTEGER := 16#0bc#;
    constant ADDR_AXI09_PTR0_DATA_1         : INTEGER := 16#0c0#;
    constant ADDR_AXI09_PTR0_CTRL           : INTEGER := 16#0c4#;
    constant ADDR_AXI10_PTR0_DATA_0         : INTEGER := 16#0c8#;
    constant ADDR_AXI10_PTR0_DATA_1         : INTEGER := 16#0cc#;
    constant ADDR_AXI10_PTR0_CTRL           : INTEGER := 16#0d0#;
    constant ADDR_AXI11_PTR0_DATA_0         : INTEGER := 16#0d4#;
    constant ADDR_AXI11_PTR0_DATA_1         : INTEGER := 16#0d8#;
    constant ADDR_AXI11_PTR0_CTRL           : INTEGER := 16#0dc#;
    constant ADDR_AXI12_PTR0_DATA_0         : INTEGER := 16#0e0#;
    constant ADDR_AXI12_PTR0_DATA_1         : INTEGER := 16#0e4#;
    constant ADDR_AXI12_PTR0_CTRL           : INTEGER := 16#0e8#;
    constant ADDR_AXI13_PTR0_DATA_0         : INTEGER := 16#0ec#;
    constant ADDR_AXI13_PTR0_DATA_1         : INTEGER := 16#0f0#;
    constant ADDR_AXI13_PTR0_CTRL           : INTEGER := 16#0f4#;
    constant ADDR_AXI14_PTR0_DATA_0         : INTEGER := 16#0f8#;
    constant ADDR_AXI14_PTR0_DATA_1         : INTEGER := 16#0fc#;
    constant ADDR_AXI14_PTR0_CTRL           : INTEGER := 16#100#;
    constant ADDR_AXI15_PTR0_DATA_0         : INTEGER := 16#104#;
    constant ADDR_AXI15_PTR0_DATA_1         : INTEGER := 16#108#;
    constant ADDR_AXI15_PTR0_CTRL           : INTEGER := 16#10c#;
    constant ADDR_BITS         : INTEGER := 9;

    signal waddr               : UNSIGNED(ADDR_BITS-1 downto 0);
    signal wmask               : UNSIGNED(31 downto 0);
    signal aw_hs               : STD_LOGIC;
    signal w_hs                : STD_LOGIC;
    signal rdata_data          : UNSIGNED(31 downto 0);
    signal ar_hs               : STD_LOGIC;
    signal raddr               : UNSIGNED(ADDR_BITS-1 downto 0);
    signal AWREADY_t           : STD_LOGIC;
    signal WREADY_t            : STD_LOGIC;
    signal ARREADY_t           : STD_LOGIC;
    signal RVALID_t            : STD_LOGIC;
    -- internal registers
    signal int_ap_idle         : STD_LOGIC;
    signal int_ap_ready        : STD_LOGIC;
    signal int_ap_done         : STD_LOGIC := '0';
    signal int_ap_start        : STD_LOGIC := '0';
    signal int_auto_restart    : STD_LOGIC := '0';
    signal int_gie             : STD_LOGIC := '0';
    signal int_ier             : UNSIGNED(1 downto 0) := (others => '0');
    signal int_isr             : UNSIGNED(1 downto 0) := (others => '0');
    signal int_csr_c_addr      : UNSIGNED(31 downto 0) := (others => '0');
    signal int_csr_r_addr      : UNSIGNED(31 downto 0) := (others => '0');
    signal int_csc_c_addr      : UNSIGNED(31 downto 0) := (others => '0');
    signal int_csc_r_addr      : UNSIGNED(31 downto 0) := (others => '0');
    signal int_level_addr      : UNSIGNED(31 downto 0) := (others => '0');
    signal int_node_num        : UNSIGNED(31 downto 0) := (others => '0');
    signal int_push_to_pull_level : UNSIGNED(31 downto 0) := (others => '0');
    signal int_pull_to_push_level : UNSIGNED(31 downto 0) := (others => '0');
    signal int_axi00_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi01_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi02_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi03_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi04_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi05_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi06_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi07_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi08_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi09_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi10_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi11_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi12_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi13_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi14_ptr0      : UNSIGNED(63 downto 0) := (others => '0');
    signal int_axi15_ptr0      : UNSIGNED(63 downto 0) := (others => '0');


begin
-- ----------------------- Instantiation------------------

-- ----------------------- AXI WRITE ---------------------
    AWREADY_t <=  '1' when wstate = wridle else '0';
    AWREADY   <=  AWREADY_t;
    WREADY_t  <=  '1' when wstate = wrdata else '0';
    WREADY    <=  WREADY_t;
    BRESP     <=  "00";  -- OKAY
    BVALID    <=  '1' when wstate = wrresp else '0';
    wmask     <=  (31 downto 24 => WSTRB(3), 23 downto 16 => WSTRB(2), 15 downto 8 => WSTRB(1), 7 downto 0 => WSTRB(0));
    aw_hs     <=  AWVALID and AWREADY_t;
    w_hs      <=  WVALID and WREADY_t;

    -- write FSM
    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                wstate <= wrreset;
            elsif (ACLK_EN = '1') then
                wstate <= wnext;
            end if;
        end if;
    end process;

    process (wstate, AWVALID, WVALID, BREADY)
    begin
        case (wstate) is
        when wridle =>
            if (AWVALID = '1') then
                wnext <= wrdata;
            else
                wnext <= wridle;
            end if;
        when wrdata =>
            if (WVALID = '1') then
                wnext <= wrresp;
            else
                wnext <= wrdata;
            end if;
        when wrresp =>
            if (BREADY = '1') then
                wnext <= wridle;
            else
                wnext <= wrresp;
            end if;
        when others =>
            wnext <= wridle;
        end case;
    end process;

    waddr_proc : process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (aw_hs = '1') then
                    waddr <= UNSIGNED(AWADDR(ADDR_BITS-1 downto 0));
                end if;
            end if;
        end if;
    end process;

-- ----------------------- AXI READ ----------------------
    ARREADY_t <= '1' when (rstate = rdidle) else '0';
    ARREADY <= ARREADY_t;
    RDATA   <= STD_LOGIC_VECTOR(rdata_data);
    RRESP   <= "00";  -- OKAY
    RVALID_t  <= '1' when (rstate = rddata) else '0';
    RVALID    <= RVALID_t;
    ar_hs   <= ARVALID and ARREADY_t;
    raddr   <= UNSIGNED(ARADDR(ADDR_BITS-1 downto 0));

    -- read FSM
    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                rstate <= rdreset;
            elsif (ACLK_EN = '1') then
                rstate <= rnext;
            end if;
        end if;
    end process;

    process (rstate, ARVALID, RREADY, RVALID_t)
    begin
        case (rstate) is
        when rdidle =>
            if (ARVALID = '1') then
                rnext <= rddata;
            else
                rnext <= rdidle;
            end if;
        when rddata =>
            if (RREADY = '1' and RVALID_t = '1') then
                rnext <= rdidle;
            else
                rnext <= rddata;
            end if;
        when others =>
            rnext <= rdidle;
        end case;
    end process;

    rdata_proc : process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (ar_hs = '1') then
                    case (TO_INTEGER(raddr)) is
                    when ADDR_AP_CTRL =>
                        rdata_data <= (7 => int_auto_restart, 3 => int_ap_ready, 2 => int_ap_idle, 1 => int_ap_done, 0 => int_ap_start, others => '0');
                    when ADDR_GIE =>
                        rdata_data <= (0 => int_gie, others => '0');
                    when ADDR_IER =>
                        rdata_data <= (1 => int_ier(1), 0 => int_ier(0), others => '0');
                    when ADDR_ISR =>
                        rdata_data <= (1 => int_isr(1), 0 => int_isr(0), others => '0');
                    when ADDR_CSR_C_ADDR_DATA_0 =>
                        rdata_data <= RESIZE(int_csr_c_addr(31 downto 0), 32);
                    when ADDR_CSR_R_ADDR_DATA_0 =>
                        rdata_data <= RESIZE(int_csr_r_addr(31 downto 0), 32);
                    when ADDR_CSC_C_ADDR_DATA_0 =>
                        rdata_data <= RESIZE(int_csc_c_addr(31 downto 0), 32);
                    when ADDR_CSC_R_ADDR_DATA_0 =>
                        rdata_data <= RESIZE(int_csc_r_addr(31 downto 0), 32);
                    when ADDR_LEVEL_ADDR_DATA_0 =>
                        rdata_data <= RESIZE(int_level_addr(31 downto 0), 32);
                    when ADDR_NODE_NUM_DATA_0 =>
                        rdata_data <= RESIZE(int_node_num(31 downto 0), 32);
                    when ADDR_PUSH_TO_PULL_LEVEL_DATA_0 =>
                        rdata_data <= RESIZE(int_push_to_pull_level(31 downto 0), 32);
                    when ADDR_PULL_TO_PUSH_LEVEL_DATA_0 =>
                        rdata_data <= RESIZE(int_pull_to_push_level(31 downto 0), 32);
                    when ADDR_AXI00_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi00_ptr0(31 downto 0), 32);
                    when ADDR_AXI00_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi00_ptr0(63 downto 32), 32);
                    when ADDR_AXI01_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi01_ptr0(31 downto 0), 32);
                    when ADDR_AXI01_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi01_ptr0(63 downto 32), 32);
                    when ADDR_AXI02_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi02_ptr0(31 downto 0), 32);
                    when ADDR_AXI02_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi02_ptr0(63 downto 32), 32);
                    when ADDR_AXI03_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi03_ptr0(31 downto 0), 32);
                    when ADDR_AXI03_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi03_ptr0(63 downto 32), 32);
                    when ADDR_AXI04_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi04_ptr0(31 downto 0), 32);
                    when ADDR_AXI04_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi04_ptr0(63 downto 32), 32);
                    when ADDR_AXI05_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi05_ptr0(31 downto 0), 32);
                    when ADDR_AXI05_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi05_ptr0(63 downto 32), 32);
                    when ADDR_AXI06_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi06_ptr0(31 downto 0), 32);
                    when ADDR_AXI06_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi06_ptr0(63 downto 32), 32);
                    when ADDR_AXI07_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi07_ptr0(31 downto 0), 32);
                    when ADDR_AXI07_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi07_ptr0(63 downto 32), 32);
                    when ADDR_AXI08_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi08_ptr0(31 downto 0), 32);
                    when ADDR_AXI08_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi08_ptr0(63 downto 32), 32);
                    when ADDR_AXI09_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi09_ptr0(31 downto 0), 32);
                    when ADDR_AXI09_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi09_ptr0(63 downto 32), 32);
                    when ADDR_AXI10_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi10_ptr0(31 downto 0), 32);
                    when ADDR_AXI10_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi10_ptr0(63 downto 32), 32);
                    when ADDR_AXI11_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi11_ptr0(31 downto 0), 32);
                    when ADDR_AXI11_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi11_ptr0(63 downto 32), 32);
                    when ADDR_AXI12_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi12_ptr0(31 downto 0), 32);
                    when ADDR_AXI12_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi12_ptr0(63 downto 32), 32);
                    when ADDR_AXI13_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi13_ptr0(31 downto 0), 32);
                    when ADDR_AXI13_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi13_ptr0(63 downto 32), 32);
                    when ADDR_AXI14_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi14_ptr0(31 downto 0), 32);
                    when ADDR_AXI14_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi14_ptr0(63 downto 32), 32);
                    when ADDR_AXI15_PTR0_DATA_0 =>
                        rdata_data <= RESIZE(int_axi15_ptr0(31 downto 0), 32);
                    when ADDR_AXI15_PTR0_DATA_1 =>
                        rdata_data <= RESIZE(int_axi15_ptr0(63 downto 32), 32);
                    when others =>
                        rdata_data <= (others => '0');
                    end case;
                end if;
            end if;
        end if;
    end process;

-- ----------------------- Register logic ----------------
    interrupt            <= int_gie and (int_isr(0) or int_isr(1));
    ap_start             <= int_ap_start;
    csr_c_addr           <= STD_LOGIC_VECTOR(int_csr_c_addr);
    csr_r_addr           <= STD_LOGIC_VECTOR(int_csr_r_addr);
    csc_c_addr           <= STD_LOGIC_VECTOR(int_csc_c_addr);
    csc_r_addr           <= STD_LOGIC_VECTOR(int_csc_r_addr);
    level_addr           <= STD_LOGIC_VECTOR(int_level_addr);
    node_num             <= STD_LOGIC_VECTOR(int_node_num);
    push_to_pull_level   <= STD_LOGIC_VECTOR(int_push_to_pull_level);
    pull_to_push_level   <= STD_LOGIC_VECTOR(int_pull_to_push_level);
    axi00_ptr0           <= STD_LOGIC_VECTOR(int_axi00_ptr0);
    axi01_ptr0           <= STD_LOGIC_VECTOR(int_axi01_ptr0);
    axi02_ptr0           <= STD_LOGIC_VECTOR(int_axi02_ptr0);
    axi03_ptr0           <= STD_LOGIC_VECTOR(int_axi03_ptr0);
    axi04_ptr0           <= STD_LOGIC_VECTOR(int_axi04_ptr0);
    axi05_ptr0           <= STD_LOGIC_VECTOR(int_axi05_ptr0);
    axi06_ptr0           <= STD_LOGIC_VECTOR(int_axi06_ptr0);
    axi07_ptr0           <= STD_LOGIC_VECTOR(int_axi07_ptr0);
    axi08_ptr0           <= STD_LOGIC_VECTOR(int_axi08_ptr0);
    axi09_ptr0           <= STD_LOGIC_VECTOR(int_axi09_ptr0);
    axi10_ptr0           <= STD_LOGIC_VECTOR(int_axi10_ptr0);
    axi11_ptr0           <= STD_LOGIC_VECTOR(int_axi11_ptr0);
    axi12_ptr0           <= STD_LOGIC_VECTOR(int_axi12_ptr0);
    axi13_ptr0           <= STD_LOGIC_VECTOR(int_axi13_ptr0);
    axi14_ptr0           <= STD_LOGIC_VECTOR(int_axi14_ptr0);
    axi15_ptr0           <= STD_LOGIC_VECTOR(int_axi15_ptr0);

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_ap_start <= '0';
            elsif (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AP_CTRL and WSTRB(0) = '1' and WDATA(0) = '1') then
                    int_ap_start <= '1';
                elsif (ap_ready = '1') then
                    int_ap_start <= int_auto_restart; -- clear on handshake/auto restart
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_ap_done <= '0';
            elsif (ACLK_EN = '1') then
                if (ap_done = '1') then
                    int_ap_done <= '1';
                elsif (ar_hs = '1' and raddr = ADDR_AP_CTRL) then
                    int_ap_done <= '0'; -- clear on read
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_ap_idle <= '0';
            elsif (ACLK_EN = '1') then
                if (true) then
                    int_ap_idle <= ap_idle;
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_ap_ready <= '0';
            elsif (ACLK_EN = '1') then
                if (true) then
                    int_ap_ready <= ap_ready;
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_auto_restart <= '0';
            elsif (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AP_CTRL and WSTRB(0) = '1') then
                    int_auto_restart <= WDATA(7);
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_gie <= '0';
            elsif (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_GIE and WSTRB(0) = '1') then
                    int_gie <= WDATA(0);
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_ier <= "00";
            elsif (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_IER and WSTRB(0) = '1') then
                    int_ier <= UNSIGNED(WDATA(1 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_isr(0) <= '0';
            elsif (ACLK_EN = '1') then
                if (int_ier(0) = '1' and ap_done = '1') then
                    int_isr(0) <= '1';
                elsif (w_hs = '1' and waddr = ADDR_ISR and WSTRB(0) = '1') then
                    int_isr(0) <= int_isr(0) xor WDATA(0); -- toggle on write
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ARESET = '1') then
                int_isr(1) <= '0';
            elsif (ACLK_EN = '1') then
                if (int_ier(1) = '1' and ap_ready = '1') then
                    int_isr(1) <= '1';
                elsif (w_hs = '1' and waddr = ADDR_ISR and WSTRB(0) = '1') then
                    int_isr(1) <= int_isr(1) xor WDATA(1); -- toggle on write
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_CSR_C_ADDR_DATA_0) then
                    int_csr_c_addr(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_csr_c_addr(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_CSR_R_ADDR_DATA_0) then
                    int_csr_r_addr(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_csr_r_addr(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_CSC_C_ADDR_DATA_0) then
                    int_csc_c_addr(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_csc_c_addr(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_CSC_R_ADDR_DATA_0) then
                    int_csc_r_addr(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_csc_r_addr(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_LEVEL_ADDR_DATA_0) then
                    int_level_addr(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_level_addr(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_NODE_NUM_DATA_0) then
                    int_node_num(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_node_num(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_PUSH_TO_PULL_LEVEL_DATA_0) then
                    int_push_to_pull_level(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_push_to_pull_level(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_PULL_TO_PUSH_LEVEL_DATA_0) then
                    int_pull_to_push_level(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_pull_to_push_level(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI00_PTR0_DATA_0) then
                    int_axi00_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi00_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI00_PTR0_DATA_1) then
                    int_axi00_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi00_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI01_PTR0_DATA_0) then
                    int_axi01_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi01_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI01_PTR0_DATA_1) then
                    int_axi01_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi01_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI02_PTR0_DATA_0) then
                    int_axi02_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi02_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI02_PTR0_DATA_1) then
                    int_axi02_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi02_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI03_PTR0_DATA_0) then
                    int_axi03_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi03_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI03_PTR0_DATA_1) then
                    int_axi03_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi03_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI04_PTR0_DATA_0) then
                    int_axi04_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi04_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI04_PTR0_DATA_1) then
                    int_axi04_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi04_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI05_PTR0_DATA_0) then
                    int_axi05_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi05_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI05_PTR0_DATA_1) then
                    int_axi05_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi05_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI06_PTR0_DATA_0) then
                    int_axi06_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi06_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI06_PTR0_DATA_1) then
                    int_axi06_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi06_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI07_PTR0_DATA_0) then
                    int_axi07_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi07_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI07_PTR0_DATA_1) then
                    int_axi07_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi07_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI08_PTR0_DATA_0) then
                    int_axi08_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi08_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI08_PTR0_DATA_1) then
                    int_axi08_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi08_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI09_PTR0_DATA_0) then
                    int_axi09_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi09_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI09_PTR0_DATA_1) then
                    int_axi09_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi09_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI10_PTR0_DATA_0) then
                    int_axi10_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi10_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI10_PTR0_DATA_1) then
                    int_axi10_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi10_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI11_PTR0_DATA_0) then
                    int_axi11_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi11_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI11_PTR0_DATA_1) then
                    int_axi11_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi11_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI12_PTR0_DATA_0) then
                    int_axi12_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi12_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI12_PTR0_DATA_1) then
                    int_axi12_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi12_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI13_PTR0_DATA_0) then
                    int_axi13_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi13_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI13_PTR0_DATA_1) then
                    int_axi13_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi13_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI14_PTR0_DATA_0) then
                    int_axi14_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi14_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI14_PTR0_DATA_1) then
                    int_axi14_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi14_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI15_PTR0_DATA_0) then
                    int_axi15_ptr0(31 downto 0) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi15_ptr0(31 downto 0));
                end if;
            end if;
        end if;
    end process;

    process (ACLK)
    begin
        if (ACLK'event and ACLK = '1') then
            if (ACLK_EN = '1') then
                if (w_hs = '1' and waddr = ADDR_AXI15_PTR0_DATA_1) then
                    int_axi15_ptr0(63 downto 32) <= (UNSIGNED(WDATA(31 downto 0)) and wmask(31 downto 0)) or ((not wmask(31 downto 0)) and int_axi15_ptr0(63 downto 32));
                end if;
            end if;
        end if;
    end process;


-- ----------------------- Memory logic ------------------

end architecture behave;
