module bram_0_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_0_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_0_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_1_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_1_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_1_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_2_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_2_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_2_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_3_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("bram_128.mem"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_3_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("bram_128.mem"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_3_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_4_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_4_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_4_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_5_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_5_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_5_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_6_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_6_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_6_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_7_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_7_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_7_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_8_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_8_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_8_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_9_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_9_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_9_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_10_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_10_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_10_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_11_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_11_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_11_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_12_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_12_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_12_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_13_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_13_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_13_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_14_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_14_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_14_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_15_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_15_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_15_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_16_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_16_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_16_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_17_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_17_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_17_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_18_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_18_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_18_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_19_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_19_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_19_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_20_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_20_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_20_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_21_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_21_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_21_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_22_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_22_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_22_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_23_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_23_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_23_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_24_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_24_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_24_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_25_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_25_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_25_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_26_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_26_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_26_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_27_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_27_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_27_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_28_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_28_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_28_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_29_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_29_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_29_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_30_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_30_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_30_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_31_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_31_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_31_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_32_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_32_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_32_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_33_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_33_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_33_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_34_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_34_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_34_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_35_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_35_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_35_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_36_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_36_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_36_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_37_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_37_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_37_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_38_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_38_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_38_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_39_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_39_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_39_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_40_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_40_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_40_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_41_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_41_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_41_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_42_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_42_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_42_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_43_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_43_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_43_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_44_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_44_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_44_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_45_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_45_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_45_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_46_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_46_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_46_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_47_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_47_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_47_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_48_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_48_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_48_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_49_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_49_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_49_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_50_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_50_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_50_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_51_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_51_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_51_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_52_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_52_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_52_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_53_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_53_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_53_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_54_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_54_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_54_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_55_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_55_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_55_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_56_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_56_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_56_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_57_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_57_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_57_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_58_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_58_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_58_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_59_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_59_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_59_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_60_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_60_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_60_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_61_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_61_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_61_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_62_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_62_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_62_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_63_0(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_63_1(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule

module bram_63_2(
  input         ena,
  input  [15:0] addra,
  input         clka,
  input  [63:0] dina,
  input         wea,
  output [63:0] douta,
  input         enb,
  input  [15:0] addrb,
  input         clkb,
  input  [63:0] dinb,
  input         web,
  output [63:0] doutb
);
xpm_memory_tdpram #(
      .ADDR_WIDTH_A(16),
      .ADDR_WIDTH_B(16),
      .AUTO_SLEEP_TIME(0),            // DECIMAL
      .BYTE_WRITE_WIDTH_A(64),        // DECIMAL
      .BYTE_WRITE_WIDTH_B(64),        // DECIMAL
      .CASCADE_HEIGHT(0),             // DECIMAL
      .CLOCKING_MODE("independent_clock"), // String
      .ECC_MODE("no_ecc"),            // String
      .MEMORY_INIT_FILE("none"),      // String
      .MEMORY_INIT_PARAM(""),        // String
      .MEMORY_OPTIMIZATION("false"),   // String
      .MEMORY_PRIMITIVE("block"),      // String
      .MEMORY_SIZE(81920),             // DECIMAL
      .MESSAGE_CONTROL(1),            // DECIMAL
      .READ_DATA_WIDTH_A(64),         // DECIMAL
      .READ_DATA_WIDTH_B(64),         // DECIMAL
      .READ_LATENCY_A(1),             // DECIMAL
      .READ_LATENCY_B(1),             // DECIMAL
      .READ_RESET_VALUE_A("0"),       // String
      .READ_RESET_VALUE_B("0"),       // String
      .RST_MODE_A("SYNC"),            // String
      .RST_MODE_B("SYNC"),            // String
      .SIM_ASSERT_CHK(0),             // DECIMAL; 0=disable simulation messages, 1=enable simulation messages
      .USE_EMBEDDED_CONSTRAINT(0),    // DECIMAL
      .USE_MEM_INIT(1),               // DECIMAL
      .WAKEUP_TIME("disable_sleep"),  // String
      .WRITE_DATA_WIDTH_A(64),        // DECIMAL
      .WRITE_DATA_WIDTH_B(64),        // DECIMAL
      .WRITE_MODE_A("read_first"),     // String
      .WRITE_MODE_B("read_first")      // String
   )
   xpm_memory_tdpram_inst (
      .dbiterra(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .dbiterrb(),             // 1-bit output: Status signal to indicate double bit error occurrence
      .douta(douta),                   // READ_DATA_WIDTH_A-bit output: Data output for port A read operations.
      .doutb(doutb),                   // READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
      .sbiterra(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .sbiterrb(),             // 1-bit output: Status signal to indicate single bit error occurrence
      .addra(addra),                   // ADDR_WIDTH_A-bit input: Address for port A write and read operations.
      .addrb(addrb),                   // ADDR_WIDTH_B-bit input: Address for port B write and read operations.
      .clka(clka),                     // 1-bit input: Clock signal for port A. Also clocks port B when
      .clkb(clkb),                     // 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is
      .dina(dina),                     // WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
      .dinb(dinb),                     // WRITE_DATA_WIDTH_B-bit input: Data input for port B write operations.
      .ena(ena),                       // 1-bit input: Memory enable signal for port A. Must be high on clock
      .enb(enb),                       // 1-bit input: Memory enable signal for port B. Must be high on clock
      .injectdbiterra(), // 1-bit input: Controls double bit error injection on input data when
      .injectdbiterrb(), // 1-bit input: Controls double bit error injection on input data when
      .injectsbiterra(), // 1-bit input: Controls single bit error injection on input data when
      .injectsbiterrb(), // 1-bit input: Controls single bit error injection on input data when
      .regcea(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .regceb(),                 // 1-bit input: Clock Enable for the last register stage on the output
      .rsta(),                     // 1-bit input: Reset signal for the final port A output register stage.
      .rstb(),                     // 1-bit input: Reset signal for the final port B output register stage.
      .sleep(),                   // 1-bit input: sleep signal to enable the dynamic power saving feature.
      .wea(wea),                       // WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector
      .web(web)                        // WRITE_DATA_WIDTH_B/BYTE_WRITE_WIDTH_B-bit input: Write enable vector
   );
endmodule
